#include "LED.cpp"
#include <map>
#include <ArduinoJson.h>

class JsonLightControl{
	std::map<const char*, LED*> _leds;

public:
	void registerLEDs(const char *name, LED *leds){
		_leds[name] = leds;
	}

	void action(std::string input){
		if (input.length() <= 0)
			return;

		Serial.println(input.c_str());

		DynamicJsonDocument document(256);
		deserializeJson(document, input.c_str());

		auto lights = document["lights"];
		Serial.println(lights.size());
		auto on = document["on"].as<bool>();
		for (int i = 0; i < lights.size(); i++)
		{
			auto name = lights[i].as<const char*>();
			auto led = _leds.find(name)->second;
			if (on)
				led->on();
			else
				led->off();
		}
	}
};
